# coding: utf-8

"""
    Order

    Filter, post or cancel orders. An order is a directive from a portfolio manager to the trading desk to execute a particular investment decision.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class PortfolioPortfolioReference(BaseModel):
    """
    Reference to a portfolio. this include the portfolio id and the portfolio ticker. Both are returned for `read` but only one of them is required for a `write`. If both are provided for a `write` then portfolio id takes precedence.
    """
    portfolio_id: Optional[StrictStr] = Field(None, alias="portfolioId")
    portfolio_ticker: Optional[StrictStr] = Field(None, alias="portfolioTicker")
    __properties = ["portfolioId", "portfolioTicker"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PortfolioPortfolioReference:
        """Create an instance of PortfolioPortfolioReference from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PortfolioPortfolioReference:
        """Create an instance of PortfolioPortfolioReference from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PortfolioPortfolioReference.parse_obj(obj)

        _obj = PortfolioPortfolioReference.parse_obj({
            "portfolio_id": obj.get("portfolioId"),
            "portfolio_ticker": obj.get("portfolioTicker")
        })
        return _obj

